/* "win2sac.c"
	"win2sac.c" convert a winformat data to sac format data
	96-04-25	*/
#include	<stdio.h>
#include	<sys/file.h>
#include	<math.h>
#include	"sac.h"

#define		SSR			250	/* max sampling rate of input data */
#define		NCH			500	/* max of output channels */

#define		NSEC		10
#define		MINUTE_SEC	60
#define		HOUR_SEC	60 * 60
#define		DAY_SEC		24 * 60 * 60



mklong(ptr)
        unsigned char *ptr;
        {
        unsigned char *ptr1;
        unsigned long a;
        ptr1=(unsigned char *)&a;
        *ptr1++=(*ptr++);
        *ptr1++=(*ptr++);
        *ptr1++=(*ptr++);
        *ptr1  =(*ptr);
        return a;
        }

mkshort(ptr)
        unsigned char *ptr;
        {
        unsigned char *ptr1;
        short a;
        ptr1=(unsigned char *)&a;
        *ptr1++=(*ptr++);
        *ptr1  =(*ptr);
        return a;
        }

adj_time(tm)
	int *tm;
	{
	if(tm[5]==60)
		{
		tm[5]=0;
		if(++tm[4]==60)
			{
			tm[4]=0;
			if(++tm[3]==24)
				{
				tm[3]=0;
				tm[2]++;
				switch(tm[1])
					{
					case 2:
						if(tm[0]%4==0)
							{
							if(tm[2]==30)
								{
								tm[2]=1;
								tm[1]++;
								}
							break;
							}
						else
							{
							if(tm[2]==29)
								{
								tm[2]=1;
								tm[1]++;
								}
							break;
							}
					case 4:
					case 6:
					case 9:
					case 11:
						if(tm[2]==31)
							{
							tm[2]=1;
							tm[1]++;
							}
						break;
					default:
						if(tm[2]==32)
							{
							tm[2]=1;
							tm[1]++;
							}
						break;
					}
				if(tm[1]==13)
					{
					tm[1]=1;
					if(++tm[0]==100) tm[0]=0;
					}
				}
			}
		}
	else if(tm[5]==-1)
		{
		tm[5]=59;
		if(--tm[4]==-1)
			{
			tm[4]=59;
			if(--tm[3]==-1)
				{
				tm[3]=23;
				if(--tm[2]==0)
					{
					switch(--tm[1])
						{
						case 2:
							if(tm[0]%4==0)
								tm[2]=29;else tm[2]=28;
							break;
						case 4:
						case 6:
						case 9:
						case 11:
							tm[2]=30;
							break;
						default:
							tm[2]=31;
							break;
						}
					if(tm[1]==0)
						{
						tm[1]=12;
						if(--tm[0]==-1) tm[0]=99;
						}
					}
				}
			}
		}
	}

bcd_dec(dest,sour)
	char *sour;
	int *dest;
	{
	int cntr;
	for(cntr=0;cntr<6;cntr++)
		dest[cntr]=((sour[cntr]>>4)&0xf)*10+(sour[cntr]&0xf);
	}

time_cmp(t1,t2)
	int *t1,*t2;
	{
	int cntr;
	for(cntr=0;cntr<6;cntr++)
		{
#ifdef SAC_DEBUG
	printf("time_cmp: %2d t1 = %2d t2 = %2d\n", cntr, t1[cntr], t2[cntr]);
#endif
		if(t1[cntr]>t2[cntr]) return 1;
		if(t1[cntr]<t2[cntr]) return -1;
		}
	return 0;
	}

main(ac,av)
int ac;
char *av[];
{
	FILE *fp, *fphyp, *fpsac;
	struct SACHD  shd;
	char  ss[128], sacdir[32];
	char  hypo_file[80];
	static char  sacf[NCH][64];
	char  name[7],stn[8], cmp[8], comp[4];
	char  evntnm[16];
	unsigned char *ptr,*ptr_end;
	unsigned char *in_data;
	char file_list[80],name_file[80];
	int sys_ch[NCH];
	int	f_in;
	int   npts[NCH], sr[NCH], srTmp;
	int dec_start[6],dec_now[6],dec_buf[6],
		i,j,nch,sys_ch0,pos,size;
	int nsjd, nerr, nlen, height;
	int neyy, nemm, nedd, njdd, nehh, nemin, nzsec, nzmsec;
	int ntype, iztype, nsec, indx;
	long lbuf[SSR];
	float vl[NCH][SSR*NSEC];
	float stla, stlo, stel;
	float ela, elo, edpth, ress;
	float dt, rb0, cmpaz, cmpinc;

	f_in=(-1);
	printf("***** win2sac start *****\n");
	if(ac<3)
		{
		printf("usage of 'win2sac' :\n");
		printf(
		" 'win2sac [YYMMDD.HHMMSS or YYMMDDHH.MM] [sac dir] ([hypo list]) ([ch list])'\n");
		exit(0);
		}
	/* read times of start and end */
	strcpy(name_file, av[1]);
	if(strlen(av[1]) > 11)
	{
		sscanf(av[1],"%2d%2d%2d.%2d%2d%2d",&dec_start[0],&dec_start[1],
			&dec_start[2],&dec_start[3],&dec_start[4], &dec_start[5]);
	}else{
		sscanf(av[1],"%2d%2d%2d%2d.%2d",&dec_start[0],&dec_start[1],
			&dec_start[2],&dec_start[3],&dec_start[4]);
		dec_start[5]=0;
	}
   if((f_in=open(name_file,O_RDONLY))==-1) {
      fprintf(stderr, "no file : %s\n",name_file);
      exit(1);
   }
   /* read the first sec data */
   if(read(f_in,&size,4)<=0) {
      fprintf(stderr, "read error\n");
		exit(2);
   }
/*
printf("in_data: size %d\n", size);
*/
	if((in_data = (unsigned char*)calloc(size, sizeof(unsigned char))) == NULL) {
		fprintf(stderr, "can not allocate memory\n");
		exit();
	}
   if(read(f_in,in_data,size-4)<=0) {
      perror("read");
  		exit(3); 
   }
	close(f_in);
   bcd_dec(dec_buf,in_data);
	/* check time of data */
   if(time_cmp(dec_start,dec_buf)) {
		fprintf(stderr, "Reset the start time\n");
		for(i=0;i<6;i++) dec_start[i]= dec_buf[i];
	}
	printf("start:%02d%02d%02d %02d%02d%02d\n",
		dec_start[0],dec_start[1],dec_start[2],
		dec_start[3],dec_start[4],dec_start[5]);
	for(i=0;i<6;i++) dec_now[i]=dec_start[i];
	jday_(dec_start[0], dec_start[1], dec_start[2], &nsjd);
	strcpy(sacdir, av[2]);
	/* read hypo list */
	if(ac == 4) {
		sscanf(av[3],"%s",hypo_file);
		if((fphyp=fopen(hypo_file,"r"))==NULL)
		{
			printf("event file '%s' not open\n",hypo_file);
			exit(1);
		}
		sscanf(fgets(ss, 128, fphyp),  "%d%d%d%d%d%f%f%f%f",
			&neyy, &nemm, &nedd, &nehh, &nemin,
			&ress, &ela, &elo, &edpth);
		if(neyy < 100)
		neyy += 1900;
		fclose(fphyp);
		jday_(neyy, nemm, nedd, &njdd);
	}else{
		neyy = dec_start[0];
		if(neyy < 100) neyy += 1900;
		nemm = dec_start[1];
		nedd = dec_start[2];
		njdd = nsjd;
		nehh = dec_start[3];
		nemin = dec_start[4];
		ress = dec_start[5];
		ela = elo = edpth = 0.;
	}
	rb0  = (float)((nsjd - njdd ) * DAY_SEC + (dec_start[3] - nehh) * HOUR_SEC +
			(dec_start[4] - nemin) * MINUTE_SEC ) + dec_start[5] - ress;
	nzsec = floor(ress);
	nzmsec = (ress - nzsec)*1000;
	if(ac == 5)
	{
		strcpy(file_list, av[4]);
	}else{
		sprintf(file_list, "%s.ch", av[1]);
	}
	/* read channel list */
	if((fp=fopen(file_list,"r"))==NULL)
	{
		printf("channel list file '%s' not open\n",file_list);
		exit(1);
	}
	nch=0;
	iztype = 11; ntype = 7;
	init_hd_(&shd);
	while(fgets(ss,128,fp))
	{
		if(ss[0] == '\n' || ss[0] == '\0') break;
		if(*ss=='#') continue;
		height=0;
		stla = stlo = 0.;
		sscanf(ss,"%s",name);
		if(strlen(name)<3)      /* old channel table format */
		{
			sscanf(ss,"%x%x%*d%*d%s%s%*d%*s%*f%*s%*f%*f%*f%*f%f%f%d",
				&i,&j,stn,comp,&stla,&stlo,&height);
			sys_ch[nch]=(i<<8)+j;
		}else{
			sscanf(ss,"%x%*d%*d%s%s%*d%*s%*f%*s%*f%*f%*f%*f%f%f%d",
				&sys_ch[nch],stn,comp,&stla,&stlo,&height);
		}
		stel=(float)height;
		fprintf(stderr, " %04X", sys_ch[nch]);
		if(!strcmp(comp, "VH"))
			sprintf(comp, "U\0");
		for(i = 0; i<strlen(comp);i++)
		if(isalpha(comp[i]))
			comp[i] = tolower(comp[i]);
		switch(comp[strlen(comp)-1]) {
			case  'u':
			case  'h':
				strncpy(cmp, "UD     ", 7);
		 		cmpaz   = 0.;
				cmpinc  = 0.;
				break;
			case  'n':
				strncpy(cmp, "NS     ", 7);
				cmpaz   = 0.;
				cmpinc  = 90.;
				break;
			case  'e':
				strncpy(cmp, "EW     ", 7);
				cmpaz   = 90.;
				cmpinc  = 90.;
				break;
			default :
				break;
		}
		if(strlen(comp) >= 2)
			sprintf(sacf[nch], "%s/%s.%cer%c",
				sacdir, stn, comp[1], comp[0]);
         	else
			sprintf(sacf[nch], "%s/%s.%cer", sacdir, stn, comp[0]);
		if((fpsac = fopen(sacf[nch], "w")) ==NULL)
		{
			fprintf(stderr, "file '%s' open error\n", sacf[nch]);
			close(f_in);
			exit();
		}
		shd.n_hd[0] = neyy; shd.n_hd[1] = njdd; shd.n_hd[2] = nehh;
		shd.n_hd[3] = nemin; shd.n_hd[4] = nzsec; shd.n_hd[5] = nzmsec;
		shd.n_hd[17] = iztype; shd.n_hd[16] = ntype;

		shd.r_hd[5] = rb0;
		shd.r_hd[35] = ela; shd.r_hd[36] = elo; shd.r_hd[37] = edpth;
		sprintf(shd.a_hd[1], "%02d/%02d/%02d\0", neyy%100, nemm, nedd);

		shd.r_hd[31] = stla; shd.r_hd[32] = stlo; shd.r_hd[33] = stel;
		shd.r_hd[57] = cmpaz; shd.r_hd[58] = cmpinc; 
		sprintf(shd.a_hd[0], "%.8s", stn);
		sprintf(shd.a_hd[20], "%.8s", comp);
		fwrite(&shd, sizeof(shd), 1, fpsac);
		fclose(fpsac);
		if(++nch==NCH) break;
	}
	fclose(fp);
	printf("\nN of channels = %d\n",nch);

	/* read win format file   */
	if((f_in=open(name_file,O_RDONLY))==-1)
	{
		fprintf(stderr, "no file : %s\n",name_file);
		exit(1);
	}
	fprintf(stderr, "'%s' opened\n",name_file);
	/* one minute loop */
	i =0;
	nsec = 0;
	free(in_data);
	while(1) {
		/* read one sec data */
		if(read(f_in,&size,4)<=0) {
			break;
		}
/*
printf("in_data: size %d\n", size);
*/
		if((in_data = (unsigned char*)calloc(size, sizeof(unsigned char))) == NULL) {
      	fprintf(stderr, "can not allocate memory\n");
      	exit();
   	}

		if(read(f_in,in_data,size-4)<=0)
		{
			perror("read");
			break;
		}
		bcd_dec(dec_buf,in_data);
		/* check time of data */
#ifdef	SAC_DEBUG
		printf("dec_now: %2d %2d %2d %2d %2d %2d\n", dec_now[0], dec_now[1],
			dec_now[2], dec_now[3], dec_now[4], dec_now[5]);
		printf("dec_buf: %2d %2d %2d %2d %2d %2d\n", dec_buf[0], dec_buf[1],
			dec_buf[2], dec_buf[3], dec_buf[4], dec_buf[5]);
#endif
		if(!time_cmp(dec_now,dec_buf)) {
			ptr=in_data+6;
			ptr_end=ptr+size-10;
			/* channel loop */
			while(ptr<ptr_end) {
				/* get one channel data */
				sys_ch0=0xffff&mkshort(ptr);
				pos = -1;
				for(i=0; i<nch; i++) {
					if(sys_ch[i] == sys_ch0) {
						pos = i;
						break;
					}
				}
/*
				printf("%d %04x %d %d\n", nsec, sys_ch0, sys_ch0, pos);
*/
				if(pos<0) {
					srTmp=get_data(&ptr,lbuf,0);
					continue;
				}
				sr[pos]=get_data(&ptr,lbuf,1);
				for(j=0;j<sr[pos];j++) {
					indx = (nsec % NSEC) * sr[pos] + j;
					vl[pos][indx]=(float)lbuf[j];
				}
				npts[pos] += sr[pos];
/*
printf("%d %d %s %d %d\n", nsec, pos, sacf[pos], sr[pos], npts[pos]);
*/
			}
		}else{
			fprintf(stderr, "win data error\n");
			close(f_in);
		}
		nsec++;
		dec_now[5]++;
		adj_time(dec_now);
		if(nsec % NSEC == 0) {
			for(i=0;i<nch;i++) {
/*
if(nsec == 60)
printf("%d %d %s\n", nsec, i, sacf[i]);
*/
				if((fpsac = fopen(sacf[i], "r+")) == NULL) {
					fprintf(stderr, "win2sac: open error [%s]\n", sacf[i]);
					exit();
				}
				fseek(fpsac, 0, 2);
/*
				if(nsec == 60){
					for(j=0; j<sr[i]*NSEC; j++) {
						printf("%d %f\n", j+1, vl[i][j]);
					}
				}
*/
				fwrite(vl[i], 4, sr[i]*NSEC, fpsac);
				fclose(fpsac);
			}
		}
		fprintf(stderr, ".");
		if(nsec % 60 == 0 )
			fprintf(stderr, " %d\n", nsec);
		free(in_data);
	}
	close(f_in);
	if(nsec % NSEC != 0) {
		for(i=0;i<nch;i++) {	
 			fpsac = fopen(sacf[i], "r+");
			fseek(fpsac, 0, 2);
			nlen =  sr[i]*(nsec%NSEC);
			fwrite(vl[i], 4, nlen, fpsac);
			fclose(fpsac);
		}
	}
	if(nsec % 60 != 0 )
		fprintf(stderr, " %d\n", nsec);
	for(i=0;i<nch;i++)
	{
		dt = 1. / sr[i];
		set_hd_(sacf[i], "delta", &dt, &nerr);
		set_hd_(sacf[i], "npts", &npts[i], &nerr);
	}
}
/*
 *	 get_data
*/
int get_data(dp,buf,idx)
unsigned char **dp;
long *buf;
int idx;
{
	unsigned char *ddp;
	int gh,s_rate,g_size,sys_ch0,i,b_size;
	ddp=(*dp);
	s_rate=(gh=mklong(ddp))&0xfff;
	ddp+=4;
	if(b_size=(gh>>12)&0xf) g_size=b_size*(s_rate-1)+4;
	else g_size=(s_rate>>1)+4;
	*dp+=4+g_size;
	sys_ch0=gh>>16;
	if(idx==0) return(s_rate);

	/* read group */
	buf[0]=mklong(ddp);
	ddp+=4;
	switch(b_size)
		{
		case 0:
			for(i=1;i<s_rate;i+=2)
				{
				buf[i]=buf[i-1]+((*(char *)ddp)>>4);
				buf[i+1]=buf[i]+(((char)(*(ddp++)<<4))>>4);
				}
			break;
		case 1:
			for(i=1;i<s_rate;i++)
				buf[i]=buf[i-1]+(*(char *)(ddp++));
			break;
		case 2:
			for(i=1;i<s_rate;i++)
				{
				buf[i]=buf[i-1]+mkshort(ddp);
				ddp+=2;
				}
			break;
		case 3:
			for(i=1;i<s_rate;i++)
				{
				buf[i]=buf[i-1]+(mklong(ddp)>>8);
				ddp+=3;
				}
			break;
		case 4:
			for(i=1;i<s_rate;i++)
				{
				buf[i]=buf[i-1]+mklong(ddp);
				ddp+=4;
				}
			break;
		default:
			return(-1);	/* bad header */
		}
	return(s_rate);	/* normal return */
}
/*
*  jday_   = change to julian day
*/
jday_(yy,  mm,  dd,  jdd)
int  yy, mm, dd;
int  *jdd;
{
   static int nmd1[12] = {   0,  31,  60,  91, 121, 152,
                       182, 213, 244, 274, 305, 335};
   static int nmd2[12] = {   0,  31,  59,  90, 120, 151,
                       181, 212, 243, 273, 304, 334};

   if(yy % 4 == 0 && yy % 100 != 0)
   {
      *jdd = nmd1[mm-1] + dd;
   }else{
      *jdd = nmd2[mm-1] + dd;
   }
}
